/*
  simple UDP client program
   (c) Junichi Akita (akita@fun.ac.jp)
 */

#include <stdio.h>
#include <string.h>
#include <sys/types.h>
#include <sys/socket.h>
#include <netinet/in.h>
#include <netdb.h>

#define PORT (10031) /* Port number for sending UDP packet to target */

main(int argc, char *argv[])
{
    struct sockaddr_in    saddr;
    struct hostent *hp;
    int fd, len, buflen, ret, port;
    char buf[1024];
    char com[5];

    if (argc == 2){
	port = PORT;
    }
    if (argc == 3){
	port = atoi(argv[2]);
    }
    else{
        printf("Usage: cl SERVER_NAME [PORT]\n"); exit(1);
    }

    if ((fd = socket(AF_INET, SOCK_DGRAM, 0)) < 0) {
        fprintf(stderr, "socket\n"); exit(1);
    }

    bzero((char *)&saddr, sizeof(saddr));

    if ((hp = gethostbyname(argv[1])) == NULL) {
        fprintf(stderr, "No such host\n");
        exit(1);
    }
    bcopy(hp->h_addr, &saddr.sin_addr, hp->h_length);
    saddr.sin_family = AF_INET;
    saddr.sin_port = htons(port);

    while (fgets(buf, 1024, stdin)) {
      //buf[strlen(buf)-1]='\0';
      buflen = strlen(buf);
      //printf("%d\n", buflen);
      if (sendto(fd, buf, buflen, 0,
		 (struct sockaddr *)&saddr, sizeof(saddr)) != buflen){
	fprintf(stderr, "sendto\n");
	exit(1);
      }
    }
    close(fd);
    exit(0);
}
