/*
  simple UDP server program
   (c) Junichi Akita (akita@fun.ac.jp)
 */

#include <stdio.h>
#include <string.h>
#include <sys/types.h>
#include <sys/socket.h>
#include <netinet/in.h>

#define DEFAULT_PORT 10030

main(int ac, char **av)
{
    int    i;
    int    fd1, fd2;
    struct sockaddr_in    saddr;
    struct sockaddr_in    caddr;
    int    len;
    int    ret;
    char   buf[1024];
    int t;
    int port;

    if (ac == 2) port = atoi(av[1]); else port = DEFAULT_PORT;

    printf("* using port %d\n", port);

    if ((fd1 = socket(AF_INET, SOCK_DGRAM, 0)) < 0) {
        perror("socket");
        exit(1);
    }

    bzero((char *)&saddr, sizeof(saddr));

    saddr.sin_family = AF_INET;
    saddr.sin_addr.s_addr = INADDR_ANY;
    saddr.sin_port = htons(port);

    if (bind(fd1, (struct sockaddr *)&saddr, sizeof(saddr)) < 0){
        perror("bind");
        exit(1);
    }
    
    len = sizeof(caddr);
    t = 0;
    while (1) {
        if ((ret = recvfrom(fd1, buf, 1024, 0,
			    (struct sockaddr *)&caddr, &len)) < 0){
            perror("recvfrom");
            exit(1);
        }
	buf[ret] = '\0';
	printf("%s\n",buf);
    }
}
